//===- MaskingInterfaces.h - Masking interfaces ---------------------------===//
//
// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.
// See https://llvm.org/LICENSE.txt for license information.
// SPDX-License-Identifier: Apache-2.0 WITH LLVM-exception
//
//===----------------------------------------------------------------------===//
//
// This file implements the interfaces for masking operations.
//
//===----------------------------------------------------------------------===//

#ifndef MLIR_DIALECT_VECTOR_INTERFACES_MASKINGINTERFACES_H_
#define MLIR_DIALECT_VECTOR_INTERFACES_MASKINGINTERFACES_H_

#include "mlir/IR/BuiltinTypes.h"
#include "mlir/IR/OpDefinition.h"

/// Include the generated interface declarations.
#include "mlir/Dialect/Vector/Interfaces/MaskingInterfaces.h.inc"

#endif // MLIR_DIALECT_VECTOR_INTERFACES_MASKINGINTERFACES_H_
